#!/usr/bin/perl

#--------- VARS ---------#

$ALERT_HOME="/usr/local/scripts/snortalert";
$CURRENT="alert.current";
$NEW="alert.new";
$DB_USER="snort";
$DB="snort";
$PASS="passwd";
#$SQL="select distinct signature, sig_name from acid_event;";
$SQL="SELECT distinct sig_reference.ref_id, acid_event.sig_name FROM sig_reference, acid_event WHERE sig_reference.sig_id = acid_event.signature;" ;
$OUMASK=`umask`;

sub output {
       format STDOUT_TOP =
Status          SID     Attack Description
--------------  ------- ------------------------------------------------------
.
format STDOUT =
@<<<<<<<<<<<<<  @<<<<<< @<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
$status,        $sid,   $info
                        @<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                        $url

.
        write;
}

#--------- MAIN ---------#
system('umask 0277');
if ( ! -f "${ALERT_HOME}/${CURRENT}" ) {
	
	system("logger -s snort-alerts \"NO $CURRENT found. It will be created for next time.\"") ;
	system("echo \"$SQL\" | mysql -u $DB_USER -p${PASS} $DB | grep -v portscan > \"$ALERT_HOME/$CURRENT\"");
	print "$ALERT_HOME/$CURRENT" ;	
	} else {

	system("echo \"$SQL\" | mysql -u $DB_USER -p${PASS} $DB | grep -v portscan> \"$ALERT_HOME/$NEW\"");
	@results=`diff \"$ALERT_HOME/$CURRENT\" \"$ALERT_HOME/$NEW\"`;
	foreach (@results) {
		my %repl = ('<' => 'Added: ', '>' => 'Removed: '); 
		$_ =~ s/([<>])/$repl{$1}/eg;
		($status, $sid, $info) = split(' ', $_, 3 ) unless ( $_ =~ /(^\d.+$|^$|^ref.+$)/ ); 
		$url="http://www.snort.org/snort-db/sid.html?sid=" . $sid ;
		output() unless ( ! defined($sid) ) ; 
	}
	system("mv \"$ALERT_HOME/$NEW\" \"$ALERT_HOME/$CURRENT\"");
}
system('umask $OUMASK >/dev/null');
